/* 페이징 관련 변수 */
let appNoticeTotalCount   = 0;
let appNoticeTotalPages   = 0;

/*aggird*/
let appNoticeAgGridData = [];

let appNoticeSelectId = "";

/****************************************************************************
 * 검색 날짜 설정
 //(A:오늘, B:3일, C:7일, D:최근30일, E:최근90일, F:이번달, G:올해, H:지난주, I:지난달)
 ****************************************************************************/
function fn_appNoticeSetDate(param){
    if("A"==param){
        // 오늘
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appNoticeSearchStartDate = year+'-'+month+'-'+day;
        appNoticeSearchEndDate   = year+'-'+month+'-'+day;
    }
    else if("B"==param){
        // 3일
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appNoticeSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        toDate.setDate(toDate.getDate() - 3);
        year  = toDate.getFullYear();
        month = toDate.getMonth() + 1;
        day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appNoticeSearchStartDate = year+'-'+month+'-'+day;
    }
    else if("C"==param){
        // 이번주
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appNoticeSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        toDate.setDate(toDate.getDate() - 7);
        year  = toDate.getFullYear();
        month = toDate.getMonth() + 1;
        day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appNoticeSearchStartDate = year+'-'+month+'-'+day;
    }
    else if("D"==param){
        // 최근30일
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        //최근30일
        toDate.setDate(toDate.getDate() - 30);
        startYear  = toDate.getFullYear();
        startMonth = toDate.getMonth() + 1;
        startDay   = toDate.getDate();

        if(startMonth < 10) startMonth = "0" + startMonth;
        if(startDay < 10) startDay = "0" + startDay;

        appNoticeSearchStartDate = startYear+'-'+startMonth+'-'+startDay;
        appNoticeSearchEndDate   = year+'-'+month+'-'+day;

    }
    else if("E"==param){
        // 최근90일
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appNoticeSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        toDate.setDate(toDate.getDate() - 90);
        year  = toDate.getFullYear();
        month = toDate.getMonth() + 1;
        day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appNoticeSearchStartDate = year+'-'+month+'-'+day;
    }
    else if("F"==param){
        //F:이번달
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appNoticeSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        appNoticeSearchStartDate = year+'-'+month+'-01';
    }
    else if("G"==param){
        // G:올해
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appNoticeSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        appNoticeSearchStartDate = year+'-01-01';
    }
    else if("H"==param){
        // H:지난주, I:지난달
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appNoticeSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        appNoticeSearchStartDate = year+'-01-01';
    }
    else if("I"==param){
        // I:지난달
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        appNoticeSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        appNoticeSearchStartDate = year+'-01-01';
    }

    $("#appNoticeSearchStartDate").val(appNoticeSearchStartDate).trigger("change");
    $("#appNoticeSearchEndDate").val(appNoticeSearchEndDate).trigger("change");
}


/****************************************************************************
 * 공지사항 정보 리스트 조회
 ****************************************************************************/
function fn_selectListAppNoticeJson(){
    let formData = new FormData();
    formData.append("menuClass", menuClass);
    formData.append("appNoticeSearchKeywordParam", appNoticeSearchKeywordParam);
    formData.append("appNoticeSort", appNoticeSort);
    formData.append("appNoticeDir", appNoticeDir);
    formData.append("appNoticeStart", appNoticeStart);
    formData.append("appNoticeLimit", appNoticeLimit);
    formData.append("appNoticeSearchStartDate", appNoticeSearchStartDate);
    formData.append("appNoticeSearchEndDate", appNoticeSearchEndDate);
    formData.append("appNoticeSearchDateType", appNoticeSearchDateType);

    $.ajax({
        url: encodeURI('/webappnotice/selectListAppNotice.do'),
        data: formData,
        dataType: "json",
        processData: false,
        contentType: false,
        type: 'POST',
        async: true,
        success: function(data){
            if('0'==data.msgCode){
                // 페이징 처리
                appNoticeTotalCount  = data.totalCount;
                //$("#txt_noticeTotalCount").text(noticeTotalCount);

                appNoticeTotalPages = Math.ceil(appNoticeTotalCount/appNoticeLimit);

                // 리스트 조회
                appNoticeAgGridData = data.rows;
                appNoticeGridOptions.api.setRowData(appNoticeAgGridData);

                if(0<data.rows.length){
                    //페이징 처리
                    window.pagObj = $('#appNoticePagination').twbsPagination({
                        startPage    : ((appNoticeStart/appNoticeLimit)+1),
                        totalPages   : (appNoticeTotalPages==0)?1:appNoticeTotalPages,
                        visiblePages : 10,
                        initiateStartPageClick: false,
                        prev         : '<img src="/image/web/page_navigation_arrow.svg" alt="prev"/>',
                        next         : '<img src="/image/web/page_navigation_arrow.svg" alt="next"/>',
                        first        : '',
                        last         : '',
                        onPageClick: function (event, page) {
                            fn_appNoticePagination(page);
                        }
                    }).on('page', function (event, page) {
                        //console.info(page + ' (from event listening)');
                    });
                }
                else{

                }
            }
            else{
                modalEvent.danger("조회 오류", data.msgDesc);
            }
        },
        error : function(xhr, status, error) {
            modalEvent.danger("조회 오류", "조회 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
        },
        beforeSend:function(){
            // 로딩열기
            appNoticeGridOptions.api.showLoadingOverlay();
        },
        complete:function(){

        }
    });
}

/****************************************************************************
 * 검색하기
 ****************************************************************************/
function fn_appNoticeSearch(param){
    if("A"!=param && "Y"!=selectUseYn){
        modalEvent.warning("", "조회 권한이 없습니다.");
        return false;
    }

    fn_appNoticePaginReset();

    appNoticeSearchKeywordParam = $("#appNoticeSearchKeyword").val();

    appNoticeSearchDateType  = $("#appNoticeSearchDateType").val();
    appNoticeSearchStartDate = $("#appNoticeSearchStartDate").val();
    appNoticeSearchEndDate   = $("#appNoticeSearchEndDate").val();

    fn_selectListAppNoticeJson();
}


/****************************************************************************
 * 초기화하기
 ****************************************************************************/
function fn_appNoticeReset(){
    fn_appNoticeSetDate('D');
    $("#appNoticeSearchDateType option:eq(0)").prop("selected", true);

    $("#appNoticeSearchKeyword").val("");

    fn_appNoticeSearch();
}

/****************************************************************************
 * 페이징 처리
 ****************************************************************************/
function fn_appNoticePagination(param){
    appNoticeStart = (parseInt(param)-1)*appNoticeLimit;

    fn_selectListAppNoticeJson();
}

/****************************************************************************
 * 페이징 리셋
 ****************************************************************************/
function fn_appNoticePaginReset(){
    appNoticeSearchKeywordParam = '';

    appNoticeStart        = 0;
    appNoticeLimit        = 100;
    appNoticeTotalCount   = 0;
    appNoticeTotalPages   = 0;

    //페이징 초기화
    if($("#appNoticePagination").data("twbs-pagination")){
        $("#appNoticePagination").twbsPagination("destroy");
    }
}

/****************************************************************************
 * 공지사항 삭제
 ****************************************************************************/
function fn_deleteAppNotice(){
    if("Y"!=deleteUseYn){
        modalEvent.warning("", "삭제 권한이 없습니다.");
        return false;
    }

    if(!appNoticeSelectId){
        modalEvent.warning("", "삭제할 대상을 선택하세요.");
        return false;
    }

    modalEvent.info("삭제", "선택한 공지사항 정보를 삭제하시겠습니까?", function(){
        let formData = new FormData();
        formData.append("menuClass", menuClass);
        formData.append("selectId", appNoticeSelectId);

        $.ajax({
            url: encodeURI('/webappnotice/deleteAppNotice.do'),
            data: formData,
            dataType: "json",
            processData: false,
            contentType: false,
            type: 'POST',
            async: true,
            success: function(data){
                if('0'==data.msgCode){
                    modalEvent.success("삭제 성공", data.msgDesc, function(){
                        fn_appNoticeOk();
                    });
                }
                else{
                    modalEvent.danger("삭제 오류", data.msgDesc);
                }
            },
            error : function(xhr, status, error) {
                modalEvent.danger("삭제 오류", "삭제 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
            },
            beforeSend:function(){

            },
            complete:function(){

            }
        });
    });
}

/****************************************************************************
 * 검색 엔터 이벤트
 ****************************************************************************/
function fn_appNoticeEnter(e){
    if(e.which){
        // 파이어폭스
        if(13 == e.which) {
            //로그인 액션 스크립트
            fn_appNoticeSearch();
        }
    }
    else{
        // 윈도우, 사파리, 크롬
        if(13 == event.keyCode) {
            //로그인 액션 스크립트
            fn_appNoticeSearch();
        }
    }
}

/****************************************************************************
 * 정렬 이벤트
 ****************************************************************************/
function fn_alignEvent(param, param2){
    let align = "";

    if("A"==param){
        align = "오늘";

        fn_appNoticeSetDate('A');
    }
    else if("B"==param){
        align = "최근30일";

        fn_appNoticeSetDate('D');
    }
    else if("C"==param){
        align = "최근90일";

        fn_appNoticeSetDate('E');
    }
    else if("D"==param){
        align = "이번주";

        fn_appNoticeSetDate('C');
    }
    else if("E"==param){
        align = "이번달";

        fn_appNoticeSetDate('F');
    }
    else if("F"==param){
        align = "올해";

        fn_appNoticeSetDate('G');
    }
    else if("G"==param){
        align = "지난주";

        fn_appNoticeSetDate('H');
    }
    else if("H"==param){
        align = "지난달";

        fn_appNoticeSetDate('I');
    }
    else{
        align = "";
    }
    $("#appNoticeSearchDateType").val(param);
    $("#appNoticeSearchDateType").siblings("button").text(align);
}

/****************************************************************************
 * 완료
 ****************************************************************************/
function fn_appNoticeOk(){
    fn_appNoticeReset();
}

function fn_insertAppNoticePopup(){
    if("Y"!=insertUseYn){
        modalEvent.warning("", "등록 권한이 없습니다.");
        return false;
    }

    let reqParam =  {};
    appNoticeInsertModal.popup(function(obj, reqParam) {
        fn_appNoticeOk();
    }, reqParam);
}

function fn_updateAppNoticePopup(param){
    let reqParam =  {
        "muAppNoticeId" : param
    };

    if("Y"==updateUseYn){
        // 수정가능
        appNoticeUpdateModal.popup(function(obj, reqParam) {
            fn_appNoticeOk();
        }, reqParam);
    }
    else{
        // 조회만
        appNoticeSelectModal.popup(function(obj, reqParam) {
            fn_appNoticeOk();
        }, reqParam);
    }

}

let appNoticeColumnDefs = [
    {field: "checkbox", headerName:"", minWidth:55, maxWidth:55, headerCheckboxSelection: true, checkboxSelection: true},
    /* {field: "rowNum", headerName:"번호", minWidth:80,maxWidth:80, sortable: false}, */
    {field: "rowNum", headerName:"번호", minWidth:60,sortable: false, cellStyle:{textAlign: 'center'}},
    {field: "title", headerName:"제목", minWidth:250, maxWidth:250, cellStyle:{cursor: 'pointer', color:'#3985EA'}},
    {field: "content", headerName:"내용",minWidth:1011},
    {field: "writeDate", headerName:"게시일",minWidth:100, maxWidth:100},
    {field: "writeName", headerName:"작성자",minWidth:100, maxWidth:100}
];

// let the grid know which columns and what data to use
let appNoticeGridOptions = {
    suppressRowTransform: true,
    columnDefs: appNoticeColumnDefs,
    defaultColDef: {		// 리스트 기본 설정
        flex: 1,
        sortable: true,		//정렬 여부
        resizable: true,	//리사이즈
        editable: true,	// 그리드에서 데이터 수정
        cellStyle:{textAlign:'left',fontSize:'14px',padding:'0'},
        //suppressSizeToFit:true,		//자동 맞춤
        //enableRowGroup: true,		// 그룹 묶음
        enablePivot: true,
        enableValue : true
    },
    //suppressMultiSort:true,  //단일솔트 true가 단일, false가 다중 shift + sort 시
    headerHeight : 41, // header 높이
    rowHeight : 41, // row 높이
    rowData : appNoticeAgGridData,
    suppressRowClickSelection : true, // 로우 클릭시 체크박스 선택 true no, false yes
    localeText : {
        noRowsToShow : '조회 결과가 없습니다.'
    }, //데이터 없을 시 나오는 문구
    rowSelection : 'multiple', // row 다중 선택
    debug : false,
    onCellClicked: function(event){ //셀 클릭 이벤트
        /* alert(event.column.colId); */
        if('title'==event.column.colId){
            fn_updateAppNoticePopup(event.data.muAppNoticeId);
        }
    },
    onSelectionChanged: function(event){ //체크박스 선택
        let selectRows = [];
        selectRows = event.api.getSelectedRows();

        appNoticeSelectId = '';
        for(let i=0; i<selectRows.length; i++){
            appNoticeSelectId += selectRows[i].muAppNoticeId + ",";
        }
        appNoticeSelectId = appNoticeSelectId.substring(0, appNoticeSelectId.lastIndexOf(','));
    },
    onSortChanged: function(event){
        //정렬
        appNoticeSort = ''; //기존 정렬 초기화
        let columnArr = event.columnApi.getColumnState();
        if(0<columnArr.length){
            //sort index 순으로 재정렬
            columnArr.sort(function(a,b){
                return a.sortIndex - b.sortIndex;
            });

            let nullCnt = 0;
            for(let i=0; i<columnArr.length; i++){
                let gridSortModel = columnArr[i].colId;
                let gridSort = columnArr[i].sort;

                if(gridSort != null){
                    appNoticeStart = 0;
                    appNoticeSort += gridSortModel+' '+ gridSort + ',';
                }
                else{
                    nullCnt++;
                    if(nullCnt == columnArr.length){
                        appNoticeSort = '';
                        appNoticeDir = '';
                        appNoticeStart = 0;
                    }
                }
            }
        }
        appNoticeSort = appNoticeSort.substring(0,appNoticeSort.lastIndexOf( ",")); //맨끝 콤마 지우기

        fn_appNoticeSearch();
    }
};

// lookup the container we want the Grid to use
let appNoticeGridDiv = document.querySelector('#appNoticeGrid');

// create the grid passing in the div to use together with the columns & data we want to use
new agGrid.Grid(appNoticeGridDiv, appNoticeGridOptions);





/****************************************************************************
 * 페이지 init
 ****************************************************************************/
function fn_pageInit(){
    // 날짜 datepicker
    fn_searchDatePicker("#divAppNoticeSearchStartDate", "#divAppNoticeSearchEndDate");

    if(!appNoticeSearchStartDate&&!appNoticeSearchEndDate){
        // 검색 오늘날짜 셋팅
        fn_appNoticeSetDate('D');
    }else{
        $("#appNoticeSearchStartDate").val(appNoticeSearchStartDate).trigger("change");;
        $("#appNoticeSearchEndDate").val(appNoticeSearchEndDate).trigger("change");;
    }

    // 초기 페이징 처리
    $("#appNoticeSearchKeyword").val(appNoticeSearchKeywordParam);

    fn_appNoticeSearch("A");
}

/****************************************************************************
 * 페이지 event
 ****************************************************************************/
function fn_pageEvent(){
    // 검색 input
    $(document).on('keypress', '#appNoticeSearchKeyword', function(e) {
        fn_appNoticeEnter(e);
    });

    // 검색 조회 버튼
    $("#btnSearchAppNotice").click(function () {
        fn_appNoticeSearch();
    });

    // 공지사항 등록 팝업 버튼
    $("#btnInsertAppNotice").click(function () {
        fn_insertAppNoticePopup();
    });

    // 공지사항 삭제 버튼
    $("#btnDeleteAppNotice").click(function () {
        fn_deleteAppNotice();
    });

    // 기간 선택 콤보 이벤트
    const target = $("#appNoticeSearchDateType").siblings("ul.select_option_list");
    target.find("li.option_list_item").click(function () {
        let selectIdArr = $(this).prop("id").split('_');
        let selectId    = selectIdArr[1];
        let selectName  = $(this).text();

        $(this).parent().siblings("button").text(selectName);
        $(this).parent().siblings("input").val(selectId);

        fn_alignEvent(selectId);
    });
}

$(function(){
    // 페이지 init
    fn_pageInit();

    // 페이지 event
    fn_pageEvent();
});